import { EditorView } from "@codemirror/next/view";
import { EditorState, Extension } from "@codemirror/next/state";
export declare enum FilterType {
    Start = 0,
    Fuzzy = 1
}
export declare class AutocompleteContext {
    readonly explicit: boolean;
    readonly filterType: FilterType;
    filter(completion: string, text: string): boolean;
}
export declare type Autocompleter = (state: EditorState, pos: number, context: AutocompleteContext) => readonly Completion[] | Promise<readonly Completion[]>;
interface AutocompleteConfig {
    override?: Autocompleter | null;
    filterType?: FilterType;
}
export interface Completion {
    label: string;
    start: number;
    end: number;
    apply?: string | ((view: EditorView) => void);
}
export declare function autocomplete(config?: AutocompleteConfig): Extension;
export declare function startCompletion(view: EditorView): boolean;
export {};
//# sourceMappingURL=index.d.ts.map