import { StringStream } from "./stringstream";
import { EditorState, Syntax, Extension } from "@codemirror/next/state";
import { Tree, NodeType, NodeProp } from "lezer-tree";
export { StringStream };
export declare type StreamParser<State> = {
    token(stream: StringStream, state: State, editorState: EditorState): string | null;
    blankLine?(state: State, editorState: EditorState): void;
    startState?(editorState: EditorState): State;
    copyState?(state: State): State;
    indent?(state: State, textAfter: string, editorState: EditorState): number;
    docProps?: readonly [NodeProp<any>, any][];
};
export declare class StreamSyntax implements Syntax {
    private field;
    extension: Extension;
    private parser;
    constructor(parser: StreamParser<any>);
    getTree(state: EditorState): Tree;
    parsePos(state: EditorState): number;
    ensureTree(state: EditorState, upto: number, timeout?: number): Tree | null;
    get docNodeType(): NodeType;
    docNodeTypeAt(): NodeType;
}
//# sourceMappingURL=stream-syntax.d.ts.map