import { Parser, ParseContext } from "lezer";
import { Tree } from "lezer-tree";
import { Text } from "@codemirror/next/text";
import { EditorState, StateField, Transaction, Syntax, Extension, StateEffectType } from "@codemirror/next/state";
export declare class LezerSyntax implements Syntax {
    readonly parser: Parser;
    readonly field: StateField<SyntaxState>;
    readonly extension: Extension;
    constructor(parser: Parser);
    getTree(state: EditorState): Tree;
    parsePos(state: EditorState): number;
    ensureTree(state: EditorState, upto: number, timeout?: number): Tree | null;
    get docNodeType(): import("lezer-tree").NodeType;
    docNodeTypeAt(state: EditorState, pos: number): import("lezer-tree").NodeType;
}
declare class SyntaxState {
    readonly tree: Tree;
    upto: number;
    cache: Tree;
    updatedTree: Tree;
    parse: ParseContext | null;
    constructor(tree: Tree, upto: number, cache: Tree);
    static advance(cache: Tree, parser: Parser, doc: Text): SyntaxState;
    apply(tr: Transaction, newState: EditorState, parser: Parser, effect: StateEffectType<SyntaxState>): SyntaxState;
    startParse(parser: Parser, doc: Text): void;
    stopParse(tree?: Tree | null, upto?: number): Tree;
}
export {};
//# sourceMappingURL=syntax.d.ts.map