import { EditorView, ViewUpdate } from "@codemirror/next/view";
import { Facet, Extension } from "@codemirror/next/state";
export declare function tooltips(): Extension;
export interface Tooltip {
    dom: HTMLElement;
    mount?(view: EditorView): void;
    update?(update: ViewUpdate): void;
    pos: number;
    style?: string;
    above?: boolean;
    strictSide?: boolean;
}
export declare const showTooltip: Facet<(view: EditorView) => Tooltip, readonly ((view: EditorView) => Tooltip)[]>;
export interface HoverTooltip {
    start: number;
    end: number;
    tooltip: (view: EditorView) => Tooltip;
}
export declare function hoverTooltip(source: (view: EditorView, check: (from: number, to: number) => boolean) => HoverTooltip | null, options?: {
    hideOnChange?: boolean;
}): Extension;
//# sourceMappingURL=tooltip.d.ts.map