import { Line } from "@codemirror/next/text";
import { SelectionRange } from "@codemirror/next/state";
export declare enum Direction {
    LTR = 0,
    RTL = 1
}
export declare class BidiSpan {
    readonly from: number;
    readonly to: number;
    readonly level: number;
    constructor(from: number, to: number, level: number);
    get dir(): Direction;
    side(end: boolean, dir: Direction): number;
    static find(order: readonly BidiSpan[], index: number, level: number, assoc: number): number;
}
export declare function computeOrder(line: string, direction: Direction): BidiSpan[];
export declare function trivialOrder(length: number): BidiSpan[];
export declare let movedOver: string;
export declare function moveVisually(line: Line, order: readonly BidiSpan[], dir: Direction, start: SelectionRange, forward: boolean): SelectionRange | null;
//# sourceMappingURL=bidi.d.ts.map