import { ChangeSet } from "@codemirror/next/state";
import { ContentView, ChildCursor, DOMPos } from "./contentview";
import { BlockView } from "./blockview";
import { Viewport } from "./viewstate";
import { DecorationSet } from "./decoration";
import { Rect } from "./dom";
import { ViewUpdate } from "./extension";
import { EditorView } from "./editorview";
export declare class DocView extends ContentView {
    readonly view: EditorView;
    children: BlockView[];
    viewports: Viewport[];
    compositionDeco: DecorationSet;
    decorations: readonly DecorationSet[];
    minWidth: number;
    minWidthFrom: number;
    minWidthTo: number;
    impreciseAnchor: DOMPos | null;
    impreciseHead: DOMPos | null;
    dom: HTMLElement;
    get root(): DocumentOrShadowRoot;
    get editorView(): EditorView;
    get length(): number;
    constructor(view: EditorView);
    update(update: ViewUpdate): boolean;
    private updateInner;
    private updateChildren;
    private replaceRange;
    updateSelection(force?: boolean, fromPointer?: boolean): void;
    enforceCursorAssoc(): void;
    mayControlSelection(): boolean;
    nearest(dom: Node): ContentView | null;
    posFromDOM(node: Node, offset: number): number;
    domAtPos(pos: number): DOMPos;
    coordsAt(pos: number, side: number): Rect | null;
    measureVisibleLineHeights(): number[];
    measureTextSize(): {
        lineHeight: number;
        charWidth: number;
    };
    childCursor(pos?: number): ChildCursor;
    computeBlockGapDeco(): DecorationSet;
    updateDeco(): DecorationSet[];
    scrollPosIntoView(pos: number, side: number): void;
}
export declare function computeCompositionDeco(view: EditorView, changes: ChangeSet): DecorationSet;
//# sourceMappingURL=docview.d.ts.map